<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WSEntryPeriodTimeBand StructType
 * @subpackage Structs
 */
class WSEntryPeriodTimeBand extends AbstractStructBase
{
    /**
     * The flags
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSKeyValue
     */
    public $flags;
    /**
     * The from
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $from;
    /**
     * The to
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $to;
    /**
     * Constructor method for WSEntryPeriodTimeBand
     * @uses WSEntryPeriodTimeBand::setFlags()
     * @uses WSEntryPeriodTimeBand::setFrom()
     * @uses WSEntryPeriodTimeBand::setTo()
     * @param \ArrayType\ArrayOfWSKeyValue $flags
     * @param int $from
     * @param int $to
     */
    public function __construct(\ArrayType\ArrayOfWSKeyValue $flags = null, $from = null, $to = null)
    {
        $this
            ->setFlags($flags)
            ->setFrom($from)
            ->setTo($to);
    }
    /**
     * Get flags value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSKeyValue|null
     */
    public function getFlags()
    {
        return isset($this->flags) ? $this->flags : null;
    }
    /**
     * Set flags value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSKeyValue $flags
     * @return \StructType\WSEntryPeriodTimeBand
     */
    public function setFlags(\ArrayType\ArrayOfWSKeyValue $flags = null)
    {
        if (is_null($flags) || (is_array($flags) && empty($flags))) {
            unset($this->flags);
        } else {
            $this->flags = $flags;
        }
        return $this;
    }
    /**
     * Get from value
     * @return int|null
     */
    public function getFrom()
    {
        return $this->from;
    }
    /**
     * Set from value
     * @param int $from
     * @return \StructType\WSEntryPeriodTimeBand
     */
    public function setFrom($from = null)
    {
        // validation for constraint: int
        if (!is_null($from) && !(is_int($from) || ctype_digit($from))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($from, true), gettype($from)), __LINE__);
        }
        $this->from = $from;
        return $this;
    }
    /**
     * Get to value
     * @return int|null
     */
    public function getTo()
    {
        return $this->to;
    }
    /**
     * Set to value
     * @param int $to
     * @return \StructType\WSEntryPeriodTimeBand
     */
    public function setTo($to = null)
    {
        // validation for constraint: int
        if (!is_null($to) && !(is_int($to) || ctype_digit($to))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($to, true), gettype($to)), __LINE__);
        }
        $this->to = $to;
        return $this;
    }
}
